stages:          # List of stages for jobs, and their order of execution
  - build
  - test
  - deploy

build-job:       # This job runs in the build stage, which runs first.
  image: maven:3.9-sapmachine-17
  stage: build
  script:
    - export VERSION_NUMBER=$(mvn help:evaluate -Dexpression=project.version -q -DforceStdout)
    - echo "VERSION_NUMBER=$VERSION_NUMBER" >> build.env
    - mvn clean install -B -Ptest
  artifacts:
    reports:
      dotenv: build.env
    name: "recpro-camunda"
    paths:
      - "$CI_PROJECT_DIR/target"
    expire_in: 1 day
    

deploy-docker-image-job:
  stage: deploy
  dependencies:
    - build-job
  image: docker:stable
  needs:
    - build-job
  cache:
    key: build
    paths:
      - "$CI_PROJECT_DIR/target"
    policy: pull
  tags:
    - docker
    # This will run a Docker daemon in a container
  # (Docker-In-Docker), which will be available at
  # thedockerhost:2375. If you make e.g. port 5000 public in
  # Docker (`docker run -p 5000:5000 yourimage`) it will be
  # exposed at thedockerhost:5000.
  services:
    - name: docker:dind
      alias: dockerdaemon

  variables:
    # Tell docker CLI how to talk to Docker daemon.
    DOCKER_HOST: tcp://dockerdaemon:2375/
    # Use the overlayfs driver for improved performance.
    DOCKER_DRIVER: overlay2
    # Disable TLS since we're running inside local network.
    DOCKER_TLS_CERTDIR: ""
  script:
    - apk add curl jq
    - mkdir -p ~/.docker/cli-plugins/
    - curl -s -L https://github.com/docker/buildx/releases/download/v0.9.1/buildx-v0.9.1.linux-amd64 -o ~/.docker/cli-plugins/docker-buildx
    - chmod a+x ~/.docker/cli-plugins/docker-buildx
    - docker login registry.gitlab.com -u $GITLAB_REGISTRY_USER  -p $GITLAB_ACCESS_TOKEN
    - docker buildx create --use
    - docker buildx build -t registry.gitlab.com/recpro-impl/recpro-camunda:latest . --platform=linux/arm64,linux/amd64 --push
    - docker buildx build -t registry.gitlab.com/recpro-impl/recpro-camunda:$VERSION_NUMBER . --platform=linux/arm64,linux/amd64 --push
  only:
    refs:
      - main
      - web
